/*
sp3_ex1.c
5/10/2005
*/

#include <stdio.h>

//define which pb model this is
#define SP3
#include "spinapi.h"

#define CLOCK 100

int main(void)
{
	int start;
	int status;

	// Locates & Initializes the PulseBlasterDDS Board
	pb_init();

	// Set Because the Board Operates at 100MHz
	set_clock(CLOCK);  
	
	// Prepare the Board to Receive Freqeuncy Values
	start_programming(FREQ_REGS);	

	// Load Frequency Register 0
	set_freq(1*MHz);
	// Load Frequency Register 1
	set_freq(2*MHz);

	
	// Prepare the Board to Receive TX Phase Values
	start_programming(PHASE_REGS_1);

	// Load Phase Register 0
	set_phase(0);
	// Load Phase Register 1
	set_phase(90);
	
	// Prepare the Board to Receive RX Phase Values
	start_programming(PHASE_REGS_0);

	// Load Phase Register 0
	set_phase(0);
	// Load Phase Register 1
	set_phase(180);
	
	
	// Prepare the Board to Receive pulse program instructions
	start_programming(PULSE_PROGRAM);

	//Instruction 0 - Continue to instruction 1 in 2us
	//Freq Reg 0, Phase Reg 1 for DAC_OUT_1, DDS TX Output ON, Phase Reg 0 for 
	//DAC_OUT_0 and DAC_OUT_2, DDS RX Output ON, Flags = 0x1FF, OPCODE = CONTINUE
	start = pb_inst(1, 0, TX_ANALOG_ON, 0, RX_ANALOG_ON, 0x1FF, CONTINUE, 0, 1*s);

	// Instruction 1 - Continue to instruction 2 in 4us
	//Freq Reg 0, Phase Reg 1 for DAC_OUT_1, DDS TX Output OFF, Phase Reg 0 for 
	//DAC_OUT_0 and DAC_OUT_2, DDS RX Output ON, Flags = 0x000, OPCODE = CONTINUE
	pb_inst(1, 0, TX_ANALOG_OFF, 0, RX_ANALOG_ON, 0x000, CONTINUE, 0, 1*s);

	// Instruction 2 - Branch to "start" (Instruction 0) in 2us
	//Freq Reg 0, Phase Reg 1 for DAC_OUT_1, DDS TX Output ON, Phase Reg 0 for 
	//DAC_OUT_0 and DAC_OUT_2, DDS RX Output ON, Flags = 0x000, OPCODE = BRANCH
	pb_inst(1, 0, TX_ANALOG_ON, 0, RX_ANALOG_ON, 0x000, BRANCH, start, 1*s);

	
	// Finished Sending Instructions
	stop_programming();

	// Run the Program
	start_pb();					
  
	status = read_status();

	printf("status: %d\n", status);
	
	// Release Control of the PulseBlasterDDS Board
	pb_close();
	

	return 0;
}

