/*
sp3_ex1.c
5/11/2005
*/

#include <stdio.h>

//define which pb model this is
#define SP3
#include "spinapi.h"

#define CLOCK 100

void main(void)
{
		int start, loop, sub; // define instruction labels

		if (pb_init() != 0)
			printf("--- Error Initializing PulseBlasterDDS ---\n");

		// Check for proper initialization of PulseBlasterDDS

		// Set clock frequency
		set_clock(CLOCK);

		// Start programming the frequency registers
		start_programming(FREQ_REGS);

		// Program the registers in order from 0 to 15
		// Valid units are MHz, kHz, and Hz - default is MHz
		set_freq(1*MHz); // Set register 0
		set_freq(2*MHz); // Set register 1
		set_freq(3*MHz); // Set register 2
		set_freq(4*MHz); // Set register 3
		set_freq(5*MHz); // Set register 4 
		set_freq(6*MHz); // Set register 5
		set_freq(7*MHz); // Set register 6
		set_freq(8*MHz); // Set register 7
		set_freq(9*MHz); // Set register 8
		set_freq(10*MHz); // Set register 9
		set_freq(11*MHz); // Set register 10
		set_freq(12*MHz); // Set register 11
		set_freq(13*MHz); // Set register 12
		set_freq(14*MHz); // Set register 13
		set_freq(15*MHz); // Set register 14
		set_freq(16*MHz); // Set register 15
		
		// Start programming the phase registers for DAC_OUT_1
		start_programming(PHASE_REGS_0);
		
		// Program the registers in order from 0 to 15
		// Units are in degrees
		set_phase(0); // Set register 0
		set_phase(22.5); // Set register 1
		set_phase(45); // Set register 2
		set_phase(67.5); // Set register 3
		set_phase(90); // Set register 4
		set_phase(112.5); // Set register 5
		set_phase(135); // Set register 6
		set_phase(157.5); // Set register 7
		set_phase(180); // Set register 8
		set_phase(202.5); // Set register 9
		set_phase(225); // Set register 10
		set_phase(247.5); // Set register 11
		set_phase(270); // Set register 12
		set_phase(292.5); // Set register 13
		set_phase(315); // Set register 14
		set_phase(337.5); // Set register 15

		// Start programming the phase registers for DAC_OUT_0 and DAC_OUT_2
		start_programming(PHASE_REGS_1);
		
		// Program the registers in order from 0 to 15
		// Units are in degrees
		set_phase(0); // Set register 0
		set_phase(22.5); // Set register 1
		set_phase(45); // Set register 2
		set_phase(67.5); // Set register 3
		set_phase(90); // Set register 4
		set_phase(112.5); // Set register 5
		set_phase(135); // Set register 6
		set_phase(157.5); // Set register 7
		set_phase(180); // Set register 8
		set_phase(202.5); // Set register 9
		set_phase(225); // Set register 10
		set_phase(247.5); // Set register 11
		set_phase(270); // Set register 12
		set_phase(292.5); // Set register 13
		set_phase(315); // Set register 14
		set_phase(337.5); // Set register 15


		//Begin pulse program
		start_programming(PULSE_PROGRAM);

	

		sub = 5; // Since we are going to jump forward in our program, we need to 
				// define this variable by hand.  Instructions start at 0 and count up

		// Instruction 0 - Jump to Subroutine at Instruction 5 in 1us
		start =	pb_inst(0,0,TX_ANALOG_ON,0,RX_ANALOG_ON,0x1FF,JSR,sub,1*us);

		// Instruction 1 - Beginning of Loop (Loop 3 times).  Continue to next instruction in 1us
		loop =	pb_inst(0,0,TX_ANALOG_OFF,0,RX_ANALOG_OFF,0x0,LOOP,3,1*us);
		
		// Instruction 2 - End of Loop.  Return to beginning of loop or continue to next instruction in 1us
				pb_inst(0,0,TX_ANALOG_ON,0,RX_ANALOG_OFF,0x0,END_LOOP,loop,1*us); 

		// Instruction 3 - Stay here for (5*1us) then continue to Instruction 4
				pb_inst(0,0,TX_ANALOG_OFF,0,RX_ANALOG_ON,0x0,LONG_DELAY,5,1*us);

		// Instruction 4 - Branch to "start" (Instruction 0) in 1us
				pb_inst(0,0,TX_ANALOG_OFF,0,RX_ANALOG_ON,0x0,BRANCH,start,1*us);

		// Instruction 5 - Continue to next instruction in 2us and reset phase
				pb_inst(0,4,TX_ANALOG_OFF,8,RX_ANALOG_ON,0x200,CONTINUE,0,2*us);
		
		// Instruction 6 - Return from Subroutine to Instruction 1 in 2us
				pb_inst(0,8,TX_ANALOG_OFF,8,RX_ANALOG_ON,0x0,RTS,0,2*us);

		// End of programming registers and pulse program
		stop_programming();

		// Start execution of the pulse program
		start_pb();

		

		// Release control of the PB board
		pb_close();
}

